\documentclass[11pt]{article}
%%%%%%%%%%%%%%%%%%%%%%%%%
%			AZ' STANDARD NEWCOMMANDS
%%%%%%%%%%%%%%%%%%%%%%%%%
%\usepackage[latin1]{inputenc}
\usepackage[english]{babel} 
\usepackage[T1]{fontenc}
\usepackage{cite, url,color} % Citation numbers being automatically sorted and properly "compressed/ranged". 
%\usepackage{pgfplots}
\usepackage{graphics,amsfonts}
\usepackage[pdftex]{graphicx}
\usepackage[cmex10]{amsmath}
% Also, note that the amsmath package sets \interdisplaylinepenalty to 10000
% thus preventing page breaks from occurring within multiline equations. Use:
 \interdisplaylinepenalty=2500
% after loading amsmath to restore such page breaks as IEEEtran.cls normally does.

\usepackage[utf8]{inputenc}
%% Useful packages for creation of two-column and more complex figures

% Compact lists
\usepackage{enumitem}

%\usepackage{./AZmacro}
%\usepackage{/Users/AZ/SVN/zanella_svn/zanella_paper/IEEETrans/algorithmic}
%\usepackage[named]{/Users/AZ/SVN/zanella_svn/zanella_paper/IEEETrans/algo}
% algorithmic.sty was written by Peter Williams and Rogerio Brito.
% This package provides an algorithmic environment fo describing algorithms.
% You can use the algorithmic environment in-text or within a figure
% environment to provide for a floating algorithm. Do NOT use the algorithm
% floating environment provided by algorithm.sty (by the same authors) or
% algorithm2e.sty (by Christophe Fiorio) as IEEE does not use dedicated
% algorithm float types and packages that provide these will not provide
% correct IEEE style captions. The latest version and documentation of
% algorithmic.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithms/

\usepackage{array}
% http://www.ctan.org/tex-archive/macros/latex/required/tools/
\usepackage{mdwmath}
\usepackage{mdwtab}
%mdwtab.sty	-- A complete ground-up rewrite of LaTeX's `tabular' and  `array' environments.  Has lots of advantages over
%		   the standard version, and over the version in `array.sty'.
% *** SUBFIGURE PACKAGES ***
\usepackage[tight,footnotesize]{subfigure}

\usepackage[top=3cm, bottom=3cm, right=3cm,left=3cm]{geometry}
\usepackage{indentfirst}

\usepackage{times}
%\usepackage[active]{srcltx}
\graphicspath{{./figure/}}

\setlength\parindent{0pt}
\linespread{1}

\def\C#1{\mathcal{#1}}

\renewcommand{\phi}{\varphi}
% OPERATORS
\newcommand{\floor}[1]{{\left\lfloor #1\right\rfloor}}
\newcommand{\ceil}[1]{{\left\lceil #1\right\rceil}}
\newcommand{\E}[1]{\mathop{\rm E}\nolimits\left[#1\right]} % Expectation
\newcommand{\pr}[1]{\Pr\left[ #1 \right]}
\renewcommand{\P}[1]{\mathrm{P}\left[ #1 \right]}

\newcommand{\mbb}{\mathbb}
\newcommand{\mrr}{\mathrm}
\newcommand{\mmin}[1]{{\min\left\{#1\right\}}}
\newcommand{\mmax}[1]{{\max\left\{#1\right\}}}
\newcommand{\id}[1]{\mathbf{1}\(#1\)} % Unit function  
\newcommand{\Heav}[1]{\mathcal{H}\left(#1\right)} % Heaviside function
\newcommand{\eps}{\varepsilon}
\newcommand{\rect}[1]{\mathrm{rect}\!\left(#1\right)}
\newcommand{\sinc}[1]{\mathrm{sinc}\!\left(#1\right)}
\newcommand{\bin}[2]{{\left(\begin{array}{c}#1\\#2\end{array}\right)}}

\newcommand{\me}[2]{\left[ {#1} \right]_{(#2)}} % Submatrix \me{P}{i,j} produces [P]_{i,j} and denotes the element in the i-th row and j-th column of P
\newcommand{\vv}[1]{\left[ {#1} \right]} % Submatrix \vv{a,b,c} produces [a,b,c]

\newcommand{\Set}[1]{{\C #1}} 
\newcommand{\Setd}[2]{\Set{#1}=\left\{#2\right\}}  % Set definition: \Set{S}{0,1,2} produces S={01,2,} where S is in mathcal 

\newcommand{\mat}[1]{{\hbox{\textbf{#1}}}}
\newcommand{\ei}[1]{{\mat{e}_{#1}}}   % all zero vector except in the $#1$-th element which is one
\newcommand{\ind}[1]{\mathbf{\chi}\left\{#1\right\}} % Indicator function \ind{A}=1 if A is true, \ind{A}=0 otherwise. 

% FORMATTING
\newcommand{\ie}{i.e.,\,}
\newcommand{\eg}{e.g.,\,}
\newcommand{\columnbreak}{\vfill\eject} % Column break

% REFERENCES
\newcommand{\Fig}[1]{Fig.~\ref{#1}}
\newcommand{\eq}[1]{(\ref{#1})}
\newcommand{\Tab}[1]{Tab.~\ref{#1}}
\newcommand{\Sec}[1]{Sec.~\ref{#1}}

% COMMENTS/REVISIONS
\newcommand{\AZ}[1]{\textit{\color{magenta}AZ says: #1}} 

\newif\ifcutshort
\cutshortfalse
\newcommand{\CS}[1]{\ifcutshort \else #1 \fi}   % cutshort

\newif\ifsol
\soltrue

\begin{document}
\title{Network Science  - AY 2019/2020\\
Homework 1: Telecommunications Network}
\author{Michael Neri ID 1232224}
\date{4 December 2020}
\maketitle



\section{Network Generation}\label{gephi} 
\begin{figure}[h!]
\centering
\includegraphics[scale=0.08]{grafoNOBG.png} 
\caption{Plotting the network using Gephi.}
\end{figure}

NSGeneratingNetwork.m is a Matlab code which generates a random network based on Telecommunications Networks in a simplified manner. Nodes represent either router or end devices while edges can be seen as physical or logical links. For this reason, multilinks and self-loops are not allowed.

At the beginning, network is composed by three routers in a triangle shape. During the generation, LANs (Local Area Network) are connected to one of the three main routers with random probabilities since not all the routers exploit the same medium (i.e. optical fiber, radio frequencies) and consequently they do not have the same capacity. 
A LAN is structured as follows:
\begin{itemize}
\item Primary Router and, if it presents, a Secondary Router. If there are two routers then they are connected directly in order to employ the HSRP protocol (Hot Standby Router Protocol).
\item Number of end devices between 1 and 150. They have a physical link to the Primary router or, if it presents, to the Secondary router.
\end{itemize}

After the LAN creation, each node connects to other end devices of all network using the Barabasi-Albert concept (preferential Attachments with initial Attactiveness) in order to simulate logical links. These connections can be seen as host-to-host links. The value of initial attractiveness is $A = 0.5$. The number of random connections at this stage is set to 2.

The number of LAN created is a parameter of the script, called "branches". The instance for this analysis has 30 branches. These can be seen in the Fig.~\ref{gephi} where in the middle there are the three initial routers and first LANs.

\section{Network analytics}



\begin{center}
\begin{tabular}{|l|l|}
\hline
N = Nodes                                                                                   & 2029           \\ \hline
L = Edges                                                                                   & 4552           \\ \hline
GC degree                                                                                   & 2029           \\ \hline
$\E{k}$                                                                               & 4.4869        \\ \hline
Maximum Degree                                                                                   & 112           \\ \hline
$\gamma$                                                                                                   & 2.0194        \\ \hline
$\E{k^2}$                                                          & 1338.0606     \\ \hline
$\E{k^3}$  & 12802733.1283 \\ \hline
$Var[k] = \E{k^2}-\E{k}^2$  & 1317.9279     \\ \hline
$\E{d}$ approximation                                                                               & 5.0729        \\ \hline
$\E{d}$ evaluated                                                                                   & 3.7256           \\ \hline
Diameter                                                                                   & 5           \\ \hline
Inhomogeneity ratio $\kappa$ & 2448.4617     \\ \hline
Mean clustering coefficient $\E{C}$ & 0.028351      \\ \hline 
Assortativity factor $\mu$                                                                                     & -0.4558       \\ \hline 
$fc = 1-\dfrac{1}{k-1}$                                                                                                       & 0.9996  \\   
\hline  
\end{tabular}
\end{center}
The total number of nodes is 2029 and all the number of edges is 4552 since the studied network is undirected and the trivial formula has been used. The node 4 has the highest degree (112 connections). Assuming that we do not know how the network is generated but only the typology, we can suppose that node 4 could be a router of the Telecommunications network. 
\begin{equation}
	L = \dfrac{\sum_{i=1}^{N}k_i}{2}
\end{equation}
Power-law concept permits to estimate the degree distribution of the node in a network.
The power-law formula is
\begin{equation}
\pr{degree=k}=\pr{k}=Ck^{\gamma}
\end{equation}
where $C$ is a constant obtained by the normalization constraint $\sum_{k=0}^{\infty}\pr{k}$.
As we can see in the previous table, the generated network follows a power-law with an $\gamma = 2.0194$ (called also slope) but it's quite difficult to estimate it correctly because of the presence of plateaus. This propriety is as expected since a telecommunication network requires high redundancy and a great number of nodes have a lot of connections.
 
The network phase is the supercritical regime since
$$
1< \E{k} < log(N)
$$
where $\E{k}$ stands for the average degree of nodes. For this reason, a giant component appears and its degree is 2029.
\begin{figure}[h]
\centering
\includegraphics[scale=0.80]{plotPFDCCDF.png} 
\caption{Plots of the power-law fitting.}
\end{figure}

System has the ultra-small-world propriety since the average distance $\E{d}$ is very small and increases as $log(log(N))$. Another propriety is the behavior of the n-th moments of $\E{k}$ which its formula is 
$$
\E{k^n} = Ck_{min}^{n-\gamma+1}\dfrac{N^{\dfrac{n}{(\gamma-1)}-1}}{n-\gamma +1}
$$

As we can see from the analytics, next moments of $\E{k}$ diverge, for $n>\gamma -1$. 
\section{Distance and diameter}
In order to obtain the distance for each node with respect to others and the diameter of the network, Matlab command \textbf{distances} is used. It returns a matrix $D$ $NxN$ which denotes every distance of the nodes. Thanks to this powerful tool, we can evaluate the average distance of the nodes, which is $E[d] = 3.7256$, by using the command mean to $D$ twice. The approximation used for this value gets $5.0729$. The diameter of the network is $5$. The value obtained is as expected because of the structure of the network. These parameters can be seen as an information flow passing through the net connecting two opposite nodes of the network. In average this path has to reach 3 hops whereas it takes 5 hops at the worst case.  

\section{Clustering Coefficients}
Clustering coefficients are used in order to evaluate the strength of connections between a specific node and its neighbors. Since its value is normalized, $C_i$ belongs to the range $[0,1]$.

The average clustering coefficient $\E{C_i}$ obtained by the script is about 0.028 which denotes a low number of links in the majority of nodes. An example of this value can be a single PC because it needs only a connection to the switch in order to comunicate with other terminals. 
\begin{figure}[h!]\label{clust}
\centering
\includegraphics[scale=0.80]{ClusteringCoeff} 
\caption{Plot of Clustering coefficient distribution.}
\end{figure}

In Fig.~\ref{clust} is shown the distribution of clustering coefficients. 

\section{Assortativity}
This section describes how nodes connect to each others. The principle of assortativity is when hubs connect with other hubs. In order to evaluate this characteristic, we have to inspect the degrees of neighboring nodes.

\begin{figure}[h!]\label{asso}
\centering
\includegraphics[scale=0.80]{Assortativity.png}
\caption{Plot of Assortativity.}
\end{figure} 

In Fig.~\ref{asso} we can see that the network is neutral until at around $k_{cutoff} \approx 10$ where the system becomes disassortative. The assortativity factor $\mu$, obtained by polynomial fitting with the distribution of the nearest neighbors degree $k_{nn}$, is $\mu = 0.4558$. 

A network can be
\begin{itemize}
	\item Assortative if $\mu>0$
	\item Neutral if $\mu\approx 0$
	\item Disassortative if $\mu<0$
\end{itemize}   

\section{Robustness}
A Telecommunication Network can be divided into two fundamental parts:
\begin{itemize}
	\item Core network where routers are connected to each others in order to apply routing algorithms.
	\item Whiskers where LANs are situated. 
\end{itemize}
Bearing in mind the previous consideration, we can imagine that a fault in the core network will probably disrupt the connectivity of hosts. For this reason, redundancy in the links is highly recommended and a great number of security devices (e.g. Uninterruptible Power Supply) are deployed for avoiding massive disconnections. 
A simulation of a random attack and an aimed attack is given in the next plot in Fig.~\ref{Rob}. In Matlab, \textbf{conncomp} and \textbf{rmnode} are used in order to simplify the execution of the code instead of duplicating the adjacency matrix and work with the copy.

\begin{figure}[h!]\label{Rob}
\centering
\includegraphics[scale=0.80]{Robustness.png}
\caption{Plot of Robustness.}
\end{figure} 
We need two parameters in order to evaluate the robustness of the network. The inhomogeneity ratio $\kappa$ is defined as 
\begin{equation}
	\kappa = \dfrac{\E{k^2}}{\E{k}}
\end{equation}
while the breaking point $f_c$ is evaluated as 
\begin{equation}
	f_c = 1-\dfrac{1}{\kappa-1}
\end{equation} 
and its value is $f_c = 0.9996$. Removing nodes randomly does not affect the network because of the elevate break-up threshold. If we remove nodes with an high number of connections first then the network disappears quite immediately. 
Shutting off the routers of a network is a catastrophic event since there will be no connection between nodes and it must be avoided.
\section*{References}
\url{https://www.cisco.com/c/en/us/support/docs/ip/hot-standby-router-protocol-hsrp/9234-hsrpguidetoc.html}

\url{http://networksciencebook.com}


\end{document}
